> ## Documentation Index
> Fetch the complete documentation index at: https://docs.seam.co/llms.txt
> Use this file to discover all available pages before exploring further.

# List Events

> Returns a list of all events. This endpoint returns the same events that would be sent to a [webhook](/developer-tools/webhooks), but it enables you to filter or see events that already took place.



## OpenAPI

````yaml /openapi.json post /events/list
openapi: 3.0.0
info:
  title: Seam Connect
  version: 1.0.0
servers:
  - url: https://connect.getseam.com
security: []
tags:
  - description: access_codes
    name: /access_codes
  - description: acs
    name: /acs
  - description: action_attempts
    name: /action_attempts
  - description: client_sessions
    name: /client_sessions
  - description: connected_accounts
    name: /connected_accounts
  - description: connect_webviews
    name: /connect_webviews
  - description: devices
    name: /devices
  - description: events
    name: /events
  - description: health
    name: /health
  - description: locks
    name: /locks
  - description: networks
    name: /networks
  - description: noise_sensors
    name: /noise_sensors
  - description: phones
    name: /phones
  - description: thermostats
    name: /thermostats
  - description: user_identities
    name: /user_identities
  - description: webhooks
    name: /webhooks
  - description: workspaces
    name: /workspaces
paths:
  /events/list:
    post:
      tags:
        - /events
      summary: List Events
      description: >-
        Returns a list of all events. This endpoint returns the same events that
        would be sent to a [webhook](/developer-tools/webhooks), but it enables
        you to filter or see events that already took place.
      operationId: eventsListPost
      requestBody:
        content:
          application/json:
            schema:
              properties:
                access_code_id:
                  description: ID of the access code for which you want to list events.
                  format: uuid
                  type: string
                access_code_ids:
                  description: IDs of the access codes for which you want to list events.
                  items:
                    format: uuid
                    type: string
                  type: array
                access_grant_id:
                  description: ID of the access grant for which you want to list events.
                  format: uuid
                  type: string
                access_grant_ids:
                  description: IDs of the access grants for which you want to list events.
                  items:
                    format: uuid
                    type: string
                  maxItems: 100
                  type: array
                access_method_id:
                  description: ID of the access method for which you want to list events.
                  format: uuid
                  type: string
                access_method_ids:
                  description: IDs of the access methods for which you want to list events.
                  items:
                    format: uuid
                    type: string
                  maxItems: 100
                  type: array
                acs_access_group_id:
                  description: >-
                    ID of the ACS access group for which you want to list
                    events.
                  format: uuid
                  type: string
                acs_credential_id:
                  description: ID of the ACS credential for which you want to list events.
                  format: uuid
                  type: string
                acs_encoder_id:
                  description: ID of the ACS encoder for which you want to list events.
                  format: uuid
                  type: string
                acs_entrance_id:
                  description: ID of the ACS entrance for which you want to list events.
                  format: uuid
                  type: string
                acs_system_id:
                  description: ID of the access system for which you want to list events.
                  format: uuid
                  type: string
                acs_system_ids:
                  description: IDs of the access systems for which you want to list events.
                  items:
                    format: uuid
                    type: string
                  type: array
                acs_user_id:
                  description: ID of the ACS user for which you want to list events.
                  format: uuid
                  type: string
                between:
                  description: >-
                    Lower and upper timestamps to define an exclusive interval
                    containing the events that you want to list. You must
                    include `since` or `between`.
                  items:
                    oneOf:
                      - type: string
                      - format: date-time
                        type: string
                  maxItems: 2
                  minItems: 2
                  type: array
                connect_webview_id:
                  description: ID of the Connect Webview for which you want to list events.
                  format: uuid
                  type: string
                connected_account_id:
                  description: >-
                    ID of the connected account for which you want to list
                    events.
                  format: uuid
                  type: string
                customer_key:
                  description: Customer key for which you want to list events.
                  type: string
                device_id:
                  description: ID of the device for which you want to list events.
                  format: uuid
                  type: string
                device_ids:
                  description: IDs of the devices for which you want to list events.
                  items:
                    format: uuid
                    type: string
                  type: array
                event_ids:
                  description: IDs of the events that you want to list.
                  items:
                    format: uuid
                    type: string
                  type: array
                event_type:
                  description: Type of the events that you want to list.
                  enum:
                    - access_code.created
                    - access_code.changed
                    - access_code.name_changed
                    - access_code.code_changed
                    - access_code.time_frame_changed
                    - access_code.mutations_requested
                    - access_code.scheduled_on_device
                    - access_code.set_on_device
                    - access_code.removed_from_device
                    - access_code.delay_in_setting_on_device
                    - access_code.failed_to_set_on_device
                    - access_code.deleted
                    - access_code.delay_in_removing_from_device
                    - access_code.failed_to_remove_from_device
                    - access_code.modified_external_to_seam
                    - access_code.deleted_external_to_seam
                    - access_code.backup_access_code_pulled
                    - access_code.unmanaged.converted_to_managed
                    - access_code.unmanaged.failed_to_convert_to_managed
                    - access_code.unmanaged.created
                    - access_code.unmanaged.removed
                    - access_grant.created
                    - access_grant.deleted
                    - access_grant.access_granted_to_all_doors
                    - access_grant.access_granted_to_door
                    - access_grant.access_to_door_lost
                    - access_grant.access_times_changed
                    - access_grant.could_not_create_requested_access_methods
                    - access_method.issued
                    - access_method.revoked
                    - access_method.card_encoding_required
                    - access_method.deleted
                    - access_method.reissued
                    - access_method.created
                    - acs_system.connected
                    - acs_system.added
                    - acs_system.disconnected
                    - acs_credential.deleted
                    - acs_credential.issued
                    - acs_credential.reissued
                    - acs_credential.invalidated
                    - acs_user.created
                    - acs_user.deleted
                    - acs_encoder.added
                    - acs_encoder.removed
                    - acs_access_group.deleted
                    - acs_entrance.added
                    - acs_entrance.removed
                    - client_session.deleted
                    - connected_account.connected
                    - connected_account.created
                    - connected_account.successful_login
                    - connected_account.disconnected
                    - connected_account.completed_first_sync
                    - connected_account.deleted
                    - connected_account.completed_first_sync_after_reconnection
                    - connected_account.reauthorization_requested
                    - action_attempt.lock_door.succeeded
                    - action_attempt.lock_door.failed
                    - action_attempt.unlock_door.succeeded
                    - action_attempt.unlock_door.failed
                    - action_attempt.simulate_keypad_code_entry.succeeded
                    - action_attempt.simulate_keypad_code_entry.failed
                    - action_attempt.simulate_manual_lock_via_keypad.succeeded
                    - action_attempt.simulate_manual_lock_via_keypad.failed
                    - connect_webview.login_succeeded
                    - connect_webview.login_failed
                    - device.connected
                    - device.added
                    - device.converted_to_unmanaged
                    - device.unmanaged.converted_to_managed
                    - device.unmanaged.connected
                    - device.disconnected
                    - device.unmanaged.disconnected
                    - device.tampered
                    - device.low_battery
                    - device.battery_status_changed
                    - device.removed
                    - device.deleted
                    - device.third_party_integration_detected
                    - device.third_party_integration_no_longer_detected
                    - device.salto.privacy_mode_activated
                    - device.salto.privacy_mode_deactivated
                    - device.connection_became_flaky
                    - device.connection_stabilized
                    - device.error.subscription_required
                    - device.error.subscription_required.resolved
                    - device.accessory_keypad_connected
                    - device.accessory_keypad_disconnected
                    - noise_sensor.noise_threshold_triggered
                    - lock.locked
                    - lock.unlocked
                    - lock.access_denied
                    - thermostat.climate_preset_activated
                    - thermostat.manually_adjusted
                    - thermostat.temperature_threshold_exceeded
                    - thermostat.temperature_threshold_no_longer_exceeded
                    - thermostat.temperature_reached_set_point
                    - thermostat.temperature_changed
                    - device.name_changed
                    - camera.activated
                    - device.doorbell_rang
                    - enrollment_automation.deleted
                    - phone.deactivated
                    - space.device_membership_changed
                    - space.created
                    - space.deleted
                  type: string
                event_types:
                  description: Types of the events that you want to list.
                  items:
                    enum:
                      - access_code.created
                      - access_code.changed
                      - access_code.name_changed
                      - access_code.code_changed
                      - access_code.time_frame_changed
                      - access_code.mutations_requested
                      - access_code.scheduled_on_device
                      - access_code.set_on_device
                      - access_code.removed_from_device
                      - access_code.delay_in_setting_on_device
                      - access_code.failed_to_set_on_device
                      - access_code.deleted
                      - access_code.delay_in_removing_from_device
                      - access_code.failed_to_remove_from_device
                      - access_code.modified_external_to_seam
                      - access_code.deleted_external_to_seam
                      - access_code.backup_access_code_pulled
                      - access_code.unmanaged.converted_to_managed
                      - access_code.unmanaged.failed_to_convert_to_managed
                      - access_code.unmanaged.created
                      - access_code.unmanaged.removed
                      - access_grant.created
                      - access_grant.deleted
                      - access_grant.access_granted_to_all_doors
                      - access_grant.access_granted_to_door
                      - access_grant.access_to_door_lost
                      - access_grant.access_times_changed
                      - access_grant.could_not_create_requested_access_methods
                      - access_method.issued
                      - access_method.revoked
                      - access_method.card_encoding_required
                      - access_method.deleted
                      - access_method.reissued
                      - access_method.created
                      - acs_system.connected
                      - acs_system.added
                      - acs_system.disconnected
                      - acs_credential.deleted
                      - acs_credential.issued
                      - acs_credential.reissued
                      - acs_credential.invalidated
                      - acs_user.created
                      - acs_user.deleted
                      - acs_encoder.added
                      - acs_encoder.removed
                      - acs_access_group.deleted
                      - acs_entrance.added
                      - acs_entrance.removed
                      - client_session.deleted
                      - connected_account.connected
                      - connected_account.created
                      - connected_account.successful_login
                      - connected_account.disconnected
                      - connected_account.completed_first_sync
                      - connected_account.deleted
                      - >-
                        connected_account.completed_first_sync_after_reconnection
                      - connected_account.reauthorization_requested
                      - action_attempt.lock_door.succeeded
                      - action_attempt.lock_door.failed
                      - action_attempt.unlock_door.succeeded
                      - action_attempt.unlock_door.failed
                      - action_attempt.simulate_keypad_code_entry.succeeded
                      - action_attempt.simulate_keypad_code_entry.failed
                      - action_attempt.simulate_manual_lock_via_keypad.succeeded
                      - action_attempt.simulate_manual_lock_via_keypad.failed
                      - connect_webview.login_succeeded
                      - connect_webview.login_failed
                      - device.connected
                      - device.added
                      - device.converted_to_unmanaged
                      - device.unmanaged.converted_to_managed
                      - device.unmanaged.connected
                      - device.disconnected
                      - device.unmanaged.disconnected
                      - device.tampered
                      - device.low_battery
                      - device.battery_status_changed
                      - device.removed
                      - device.deleted
                      - device.third_party_integration_detected
                      - device.third_party_integration_no_longer_detected
                      - device.salto.privacy_mode_activated
                      - device.salto.privacy_mode_deactivated
                      - device.connection_became_flaky
                      - device.connection_stabilized
                      - device.error.subscription_required
                      - device.error.subscription_required.resolved
                      - device.accessory_keypad_connected
                      - device.accessory_keypad_disconnected
                      - noise_sensor.noise_threshold_triggered
                      - lock.locked
                      - lock.unlocked
                      - lock.access_denied
                      - thermostat.climate_preset_activated
                      - thermostat.manually_adjusted
                      - thermostat.temperature_threshold_exceeded
                      - thermostat.temperature_threshold_no_longer_exceeded
                      - thermostat.temperature_reached_set_point
                      - thermostat.temperature_changed
                      - device.name_changed
                      - camera.activated
                      - device.doorbell_rang
                      - enrollment_automation.deleted
                      - phone.deactivated
                      - space.device_membership_changed
                      - space.created
                      - space.deleted
                    type: string
                  type: array
                limit:
                  default: 500
                  description: Numerical limit on the number of events to return.
                  format: float
                  type: number
                since:
                  description: >-
                    Timestamp to indicate the beginning generation time for the
                    events that you want to list. You must include `since` or
                    `between`.
                  type: string
                space_id:
                  description: ID of the space for which you want to list events.
                  format: uuid
                  type: string
                space_ids:
                  description: IDs of the spaces for which you want to list events.
                  items:
                    format: uuid
                    type: string
                  maxItems: 100
                  type: array
                unstable_offset:
                  description: Offset for the events that you want to list.
                  format: float
                  type: number
                user_identity_id:
                  description: ID of the user identity for which you want to list events.
                  format: uuid
                  type: string
              type: object
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  events:
                    items:
                      $ref: '#/components/schemas/event'
                    type: array
                required:
                  - events
                type: object
          description: OK
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
      security:
        - client_session: []
        - api_key: []
        - pat_with_workspace: []
        - console_session_with_workspace: []
        - client_session_with_customer: []
      x-codeSamples:
        - lang: javascript
          label: Seam SDK
          source: |-
            await seam.events.list({
              device_id: "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
              since: "2025-05-15T00:00:00.000Z",
              limit: 10,
            });

            /*
            [
              {
                "connected_account_id": "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
                "created_at": "2025-06-15T16:54:18.000000Z",
                "device_id": "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
                "event_description": "The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
                "event_id": "6d7e8f9a-1b2c-3d4e-5f6a-7b8c9d0e1f2a",
                "event_type": "device.connected",
                "occurred_at": "2025-06-15T16:54:17.946329Z",
                "workspace_id": "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d"
              }
            ]
            */
        - lang: bash
          label: cURL
          source: >-
            curl --include --request POST
            "https://connect.getseam.com/events/list" \
              --header "Authorization: Bearer $SEAM_API_KEY" \
              --json @- <<EOF
            {
              "device_id": "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
              "since": "2025-05-15T00:00:00.000Z",
              "limit": 10
            }

            EOF


            # Response:

            # {

            #   "events": [

            #     {

            #       "connected_account_id":
            "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",

            #       "created_at": "2025-06-15T16:54:18.000000Z",

            #       "device_id": "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",

            #       "event_description": "The status of a device changed from
            offline to online. That is, the device.properties.online property
            changed from false to true. Note that some devices operate entirely
            in offline mode, so Seam never emits a device.connected event for
            these devices.",

            #       "event_id": "6d7e8f9a-1b2c-3d4e-5f6a-7b8c9d0e1f2a",

            #       "event_type": "device.connected",

            #       "occurred_at": "2025-06-15T16:54:17.946329Z",

            #       "workspace_id": "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d"

            #     }

            #   ]

            # }
        - lang: python
          label: Seam SDK
          source: |-
            seam.events.list(
                device_id="b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
                since="2025-05-15T00:00:00.000Z",
                limit=10,
            )

            # [
                SeamEvent(
                    connected_account_id="2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
                    created_at="2025-06-15T16:54:18.000000Z",
                    device_id="b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
                    event_description="The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
                    event_id="6d7e8f9a-1b2c-3d4e-5f6a-7b8c9d0e1f2a",
                    event_type="device.connected",
                    occurred_at="2025-06-15T16:54:17.946329Z",
                    workspace_id="9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d",
                )
            ]
        - lang: ruby
          label: Seam SDK
          source: |-
            seam.events.list(
              device_id: "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
              since: "2025-05-15T00:00:00.000Z",
              limit: 10,
            )

            # => [
              {
                "connected_account_id" => "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
                "created_at" => "2025-06-15T16:54:18.000000Z",
                "device_id" => "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
                "event_description" =>
                  "The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
                "event_id" => "6d7e8f9a-1b2c-3d4e-5f6a-7b8c9d0e1f2a",
                "event_type" => "device.connected",
                "occurred_at" => "2025-06-15T16:54:17.946329Z",
                "workspace_id" => "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d",
              },
            ]
        - lang: php
          label: Seam SDK
          source: |-
            $seam->events->list(
                device_id: "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
                since: "2025-05-15T00:00:00.000Z",
                limit: 10,
            );

            // [
                [
                    "connected_account_id" => "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
                    "created_at" => "2025-06-15T16:54:18.000000Z",
                    "device_id" => "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",
                    "event_description" =>
                        "The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
                    "event_id" => "6d7e8f9a-1b2c-3d4e-5f6a-7b8c9d0e1f2a",
                    "event_type" => "device.connected",
                    "occurred_at" => "2025-06-15T16:54:17.946329Z",
                    "workspace_id" => "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d",
                ],
            ];
        - lang: bash
          label: Seam CLI
          source: >-
            seam events list --device_id "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2"
            --since "2025-05-15T00:00:00.000Z" --limit 10


            # [

            #   {

            #     "connected_account_id":
            "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",

            #     "created_at": "2025-06-15T16:54:18.000000Z",

            #     "device_id": "b2ebca6c-d6d1-47dd-8dae-e9fa06f060b2",

            #     "event_description": "The status of a device changed from
            offline to online. That is, the device.properties.online property
            changed from false to true. Note that some devices operate entirely
            in offline mode, so Seam never emits a device.connected event for
            these devices.",

            #     "event_id": "6d7e8f9a-1b2c-3d4e-5f6a-7b8c9d0e1f2a",

            #     "event_type": "device.connected",

            #     "occurred_at": "2025-06-15T16:54:17.946329Z",

            #     "workspace_id": "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d"

            #   }

            # ]
components:
  schemas:
    event:
      description: >-
        Represents an event. Events let you know when something interesting
        happens in your workspace. For example, when a lock is unlocked, Seam
        creates a `lock.unlocked` event. When a device's battery level is low,
        Seam creates a `device.battery_low` event. See the [event
        object](/api/events/object).
      discriminator:
        propertyName: event_type
      oneOf:
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            created.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.created
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            changed.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            change_reason:
              description: >-
                Human-readable reason for the change (e.g. `ongoing code
                auto-renewed`).
              type: string
            changed_properties:
              description: List of properties that changed on the access code.
              items:
                description: Record describing a single changed property.
                properties:
                  from:
                    description: Previous value of the property, or null if not set.
                    nullable: true
                    type: string
                  property:
                    description: Name of the property that changed (e.g. `code`).
                    type: string
                  to:
                    description: New value of the property, or null if cleared.
                    nullable: true
                    type: string
                required:
                  - property
                  - from
                  - to
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.changed
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            The name of an [access
            code](/low-level-apis/smart-locks/access-codes) was changed on the
            device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            description:
              description: Human-readable description of the change and its source.
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.name_changed
              type: string
            from:
              description: Previous access code name configuration.
              properties:
                name:
                  description: Previous name of the access code.
                  nullable: true
                  type: string
              required:
                - name
              type: object
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            to:
              description: New access code name configuration.
              properties:
                name:
                  description: New name of the access code.
                  nullable: true
                  type: string
              required:
                - name
              type: object
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - from
            - to
            - description
          type: object
          x-route-path: /access_codes
        - description: >-
            The pin code of an [access
            code](/low-level-apis/smart-locks/access-codes) was changed on the
            device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            description:
              description: Human-readable description of the change and its source.
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.code_changed
              type: string
            from:
              description: Previous pin code configuration.
              properties:
                code:
                  description: Previous pin code.
                  nullable: true
                  type: string
              required:
                - code
              type: object
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            to:
              description: New pin code configuration.
              properties:
                code:
                  description: New pin code.
                  nullable: true
                  type: string
              required:
                - code
              type: object
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - from
            - to
            - description
          type: object
          x-route-path: /access_codes
        - description: >-
            The time frame of an [access
            code](/low-level-apis/smart-locks/access-codes) was changed on the
            device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            description:
              description: Human-readable description of the change and its source.
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.time_frame_changed
              type: string
            from:
              description: Previous time frame configuration.
              properties:
                ends_at:
                  description: Previous end time.
                  nullable: true
                  type: string
                starts_at:
                  description: Previous start time.
                  nullable: true
                  type: string
              required:
                - starts_at
                - ends_at
              type: object
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            to:
              description: New time frame configuration.
              properties:
                ends_at:
                  description: New end time.
                  nullable: true
                  type: string
                starts_at:
                  description: New start time.
                  nullable: true
                  type: string
              required:
                - starts_at
                - ends_at
              type: object
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - from
            - to
            - description
          type: object
          x-route-path: /access_codes
        - description: >-
            Mutations were requested on an [access
            code](/low-level-apis/smart-locks/access-codes). This event fires at
            request time, before the change is confirmed on the device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.mutations_requested
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            requested_mutations:
              description: >-
                Array of mutations requested on the access code, each containing
                the mutation type and from/to values.
              items:
                description: Record describing a single requested mutation.
                properties:
                  from:
                    additionalProperties: {}
                    description: >-
                      Previous property values before the requested change. Keys
                      depend on the mutation type. Absent for non-property
                      mutations like `deleting`.
                    type: object
                  mutation_code:
                    description: >-
                      Code identifying the type of mutation requested, such as
                      `updating_name`, `updating_code`, `updating_time_frame`,
                      or `deleting`.
                    enum:
                      - updating_name
                      - updating_code
                      - updating_time_frame
                      - deleting
                      - creating
                      - deferring_creation
                    type: string
                  to:
                    additionalProperties: {}
                    description: >-
                      New property values after the requested change. Keys
                      depend on the mutation type. Absent for non-property
                      mutations like `deleting`.
                    type: object
                required:
                  - mutation_code
                type: object
              type: array
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - requested_mutations
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            [scheduled
            natively](/low-level-apis/smart-locks/access-codes#native-scheduling)
            on a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            code:
              description: Code for the affected access code.
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.scheduled_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - code
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was set
            on a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            code:
              description: Code for the affected access code.
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.set_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - code
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            removed from a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.removed_from_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            There was an unusually long delay in setting an [access
            code](/low-level-apis/smart-locks/access-codes) on a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.delay_in_setting_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) failed to
            be set on a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.failed_to_set_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            deleted.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            code:
              description: Code for the affected access code.
              nullable: true
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.deleted
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - code
          type: object
          x-route-path: /access_codes
        - description: >-
            There was an unusually long delay in removing an [access
            code](/low-level-apis/smart-locks/access-codes) from a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.delay_in_removing_from_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) failed to
            be removed from a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the connected account associated with the affected access
                code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                description: >-
                  Error associated with the resource, including the error code,
                  message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                description: >-
                  Warning associated with the resource, including the warning
                  code, message, and creation timestamp.
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_description:
              description: >-
                Human-readable description of the event. Persisted when the
                event is created (so the creating code, including a provider,
                can supply a tailored description) and otherwise derived from
                the event.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.failed_to_remove_from_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: ID of the workspace associated with the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
[...]
